From 6c79e17ce524d0525ccd5bf279608dd5f2fba781 Mon Sep 17 00:00:00 2001
From: Amitosh Swain Mahapatra <amitosh.swain@gmail.com>
Date: May 30 2018 07:00:27 +0000
Subject: [PATCH 2/4] Use Observables instead of Promises to match with Angular API


---

diff --git a/src/app/app.module.ts b/src/app/app.module.ts
index 1378f59..3c5e34c 100644
--- a/src/app/app.module.ts
+++ b/src/app/app.module.ts
@@ -18,10 +18,6 @@ import { SocialPage } from '../pages/social/social';
 import { WomenPage } from '../pages/women/women';
 
 import { Browser } from '../providers/browser/browser';
-import { Http } from '../providers/http/http';
-import { IonicConfig } from '../providers/ionic-config/ionic-config';
-import { FacebookProvider } from '../providers/social/facebook';
-import { TwitterProvider } from '../providers/social/twitter';
 
 @NgModule({
   declarations: [
@@ -50,16 +46,12 @@ import { TwitterProvider } from '../providers/social/twitter';
   ],
   providers: [
     Browser,
-    IonicConfig,
     InAppBrowser,
-    Http,
     SocialSharing,
     SplashScreen,
     SpinnerDialog,
     StatusBar,
     Toast,
-    FacebookProvider,
-    TwitterProvider,
     { provide: ErrorHandler, useClass: IonicErrorHandler },
   ]
 })
diff --git a/src/pages/ask/ask.ts b/src/pages/ask/ask.ts
index 7cf52af..e61edc1 100644
--- a/src/pages/ask/ask.ts
+++ b/src/pages/ask/ask.ts
@@ -29,7 +29,7 @@ export class AskPage {
   updateQuestions() {
     this.askFedora
       .getQuestions()
-      .then(questions => {
+      .subscribe(questions => {
         this.questions = questions;
       });
   }
diff --git a/src/pages/calendar/calendar.ts b/src/pages/calendar/calendar.ts
index b5b0771..1ec2f2b 100644
--- a/src/pages/calendar/calendar.ts
+++ b/src/pages/calendar/calendar.ts
@@ -1,7 +1,7 @@
 import { Component } from '@angular/core';
 import { Calendar } from '@ionic-native/calendar';
 
-import { FedoCal } from '../../providers/fedo-cal/fedo-cal';
+import { FedoCalService, Calendar as CalendarType } from '../../providers/fedo-cal/fedo-cal';
 
 /*
   Generated class for the CalendarPage page.
@@ -14,14 +14,14 @@ const DEFAULT_CALENDAR = 'QA';
 
 @Component({
   templateUrl: 'calendar.html',
-  providers: [ FedoCal, Calendar ]
+  providers: [FedoCalService, Calendar]
 })
 export class CalendarPage {
-  private calendars:Array<any>;
-  private meetings:Array<any>;
-  private selectedCalendar:string;
+  private calendars: CalendarType[];
+  private meetings: Array<any>;
+  private selectedCalendar: string;
 
-  constructor(private fedoCal:FedoCal, private calendar:Calendar) {
+  constructor(private fedoCal: FedoCalService, private calendar: Calendar) {
     this.calendars = [];
     this.meetings = [];
 
@@ -36,7 +36,7 @@ export class CalendarPage {
   updateCalendars() {
     this.fedoCal
       .getCalendars()
-      .then(calendars => {
+      .subscribe(calendars => {
         this.calendars = calendars;
       });
   }
@@ -44,7 +44,7 @@ export class CalendarPage {
   updateMeetings() {
     this.fedoCal
       .getMeetings(this.selectedCalendar)
-      .then(meetings => {
+      .subscribe(meetings => {
         this.meetings = meetings;
       });
   }
diff --git a/src/pages/first/first.ts b/src/pages/first/first.ts
index 5bce2e7..e6574ae 100644
--- a/src/pages/first/first.ts
+++ b/src/pages/first/first.ts
@@ -3,7 +3,6 @@ import { NavController } from 'ionic-angular';
 import { SocialSharing } from '@ionic-native/social-sharing';
 
 import { Browser } from '../../providers/browser/browser';
-import { FedoraMag } from '../../providers/fedora-mag/fedora-mag';
 import { MagazinePage } from '../magazine/magazine';
 import { AskPage } from '../ask/ask';
 import { CalendarPage } from '../calendar/calendar';
@@ -17,27 +16,15 @@ import { SocialPage } from '../social/social';
 */
 @Component({
   templateUrl: 'first.html',
-  providers: [ FedoraMag ]
 })
 
 export class FirstPage {
   private posts: Array<any>;
 
-  constructor(private nav: NavController, private browser: Browser,
-    private fedoraMag: FedoraMag, private socialSharing: SocialSharing) {
+  constructor(private nav: NavController, private browser: Browser, private socialSharing: SocialSharing) {
     this.posts = [];
   }
 
-  ngOnInit() {
-    this.updatePosts();
-  }
-
-  updatePosts() {
-    this.fedoraMag.getPosts().then(posts => {
-      this.posts = posts;
-    });
-  }
-
   openPost(event) {
     this.browser.open(event.link);
   }
@@ -58,11 +45,4 @@ export class FirstPage {
   login(event) {
 
   }
-
-  sharePost(event) {
-    this.socialSharing.share(
-      event.title, event.title,
-      null, event.link
-    );
-  }
 }
diff --git a/src/pages/magazine/magazine.ts b/src/pages/magazine/magazine.ts
index 7f2f426..b0c724f 100644
--- a/src/pages/magazine/magazine.ts
+++ b/src/pages/magazine/magazine.ts
@@ -2,7 +2,7 @@ import { Component } from '@angular/core';
 import { SocialSharing } from '@ionic-native/social-sharing';
 
 import { Browser } from '../../providers/browser/browser';
-import { FedoraMag } from '../../providers/fedora-mag/fedora-mag';
+import { FedoraMagazineService, Post } from '../../providers/fedora-magazine/fedora-magazine';
 
 /*
   Generated class for the MagazinePage page.
@@ -12,13 +12,13 @@ import { FedoraMag } from '../../providers/fedora-mag/fedora-mag';
 */
 @Component({
   templateUrl: 'magazine.html',
-  providers: [FedoraMag],
+  providers: [FedoraMagazineService],
 })
 export class MagazinePage {
-  private posts:Array<any>;
+  private posts: Post[];
 
-  constructor(private browser:Browser,
-    private fedoraMag:FedoraMag, private socialSharing:SocialSharing) {
+  constructor(private browser: Browser,
+    private fedoraMag: FedoraMagazineService, private socialSharing: SocialSharing) {
     this.posts = [];
   }
 
@@ -27,9 +27,10 @@ export class MagazinePage {
   }
 
   updatePosts() {
-    this.fedoraMag.getPosts().then(posts => {
-      this.posts = posts;
-    });
+    this.fedoraMag.getPosts()
+      .subscribe(posts => {
+        this.posts = posts;
+      });
   }
 
   openPost(event) {
diff --git a/src/pages/social/social.ts b/src/pages/social/social.ts
index 0b30a6f..185dd8d 100644
--- a/src/pages/social/social.ts
+++ b/src/pages/social/social.ts
@@ -5,6 +5,12 @@ import { Browser } from '../../providers/browser/browser';
 import { FacebookProvider } from '../../providers/social/facebook';
 import { TwitterProvider } from '../../providers/social/twitter';
 import { Post } from '../../providers/social/social';
+import { forkJoin } from 'rxjs/observable/forkJoin';
+
+const HANDLE = {
+  FB: 'fedoraqa',
+  TWITTER: 'fedora_qa',
+};
 
 /*
   Generated class for the SocialPage page.
@@ -18,53 +24,28 @@ import { Post } from '../../providers/social/social';
 })
 export class SocialPage {
 
-  private posts:Post[];
-  private tweets:Post[];
-  private updates:Array<any>;
-  private USER:any;
-
-  constructor(private browser:Browser, private fb:FacebookProvider, private tw:TwitterProvider,
-              private socialSharing:SocialSharing) {
+  private posts: Post[];
+  constructor(private browser: Browser, private fb: FacebookProvider, private twitter: TwitterProvider,
+    private socialSharing: SocialSharing) {
     this.posts = [];
-    this.tweets = [];
-    this.updates = [];
-
-    this.USER = {
-      FB: 'fedoraqa',
-      TW: 'fedora_qa',
-    };
   }
 
   ngOnInit() {
-    this.updateUpdates();
+    this.updatePosts();
   }
 
-  updateUpdates() {
-    this.fb
-      .getPosts(this.USER.FB)
-      .then((posts:Array<any>) => {
-        this.posts = posts;
-        this.mergeUpdates();
+  private updatePosts() {
+    forkJoin(this.fb.getPosts(HANDLE.FB), this.twitter.getPosts(HANDLE.TWITTER))
+      .subscribe(values => {
+        this.posts = [...values[0], ...values[1]] as Post[];
       });
-
-    this.tw
-      .getPosts(this.USER.TW)
-      .then((tweets:Array<any>) => {
-        this.tweets = tweets;
-        this.mergeUpdates();
-      });
-  }
-
-  mergeUpdates() {
-    // TODO: Merge as per ascending order of timestamps?
-    this.updates = [ ...this.posts, ...this.tweets ];
   }
 
-  openUpdate(event) {
+  openPost(event) {
     this.browser.open(event.link);
   }
 
-  shareUpdate(event) {
+  sharePost(event) {
     this.socialSharing.share(
       event.title,
       event.title,
diff --git a/src/pages/women/women.ts b/src/pages/women/women.ts
index 31282e2..7ef83df 100644
--- a/src/pages/women/women.ts
+++ b/src/pages/women/women.ts
@@ -1,13 +1,4 @@
 import { Component } from '@angular/core';
-import { NavController } from 'ionic-angular';
-import { SocialSharing } from '@ionic-native/social-sharing';
-
-import { Browser } from '../../providers/browser/browser';
-import { FedoraMag } from '../../providers/fedora-mag/fedora-mag';
-import { MagazinePage } from '../magazine/magazine';
-import { AskPage } from '../ask/ask';
-import { CalendarPage } from '../calendar/calendar';
-import { SocialPage } from '../social/social';
 
 /*
   Generated class for the MagazinePage page.
@@ -17,51 +8,6 @@ import { SocialPage } from '../social/social';
 */
 @Component({
   templateUrl: 'women.html',
-  providers: [Browser, FedoraMag],
 })
 export class WomenPage {
-  posts: Array<any>;
-
-  constructor(private nav: NavController, private browser: Browser,
-    private fedoraMag: FedoraMag, private socialSharing: SocialSharing) {
-    this.posts = [];
-  }
-
-  ngOnInit() {
-    this.updatePosts();
-  }
-
-  updatePosts() {
-    this.fedoraMag.getPosts().then(posts => {
-      this.posts = posts;
-    });
-  }
-
-  openPost(event) {
-    this.browser.open(event.link);
-  }
-
-  openMag() {
-    this.nav.push(MagazinePage);
-  }
-  openAsk() {
-    this.nav.push(AskPage);
-  }
-  openSocial() {
-    this.nav.push(SocialPage);
-  }
-  openCal() {
-    this.nav.push(CalendarPage);
-  }
-
-  login(event) {
-
-  }
-
-  sharePost(event) {
-    this.socialSharing.share(
-      event.title, event.title,
-      null, event.link
-    );
-  }
 }
diff --git a/src/providers/ask-fedora/ask-fedora.ts b/src/providers/ask-fedora/ask-fedora.ts
index f32e1cf..9775aff 100644
--- a/src/providers/ask-fedora/ask-fedora.ts
+++ b/src/providers/ask-fedora/ask-fedora.ts
@@ -1,9 +1,12 @@
-import { Injectable } from '@angular/core';
 import 'rxjs/add/operator/map';
+import { Injectable } from '@angular/core';
 
-import { Http } from '../http/http';
+import { HttpClient } from '@angular/common/http';
+import { Platform } from 'ionic-angular';
 
-const API_ENDPOINT = 'https://ask.fedoraproject.org/en/api/v1';
+import { chooseEndpoint } from '../../utils';
+
+const ENDPOINT = chooseEndpoint('/ask-fedora', 'https://ask.fedoraproject.org/en/api/v1');
 
 export interface Question {
   id: string,
@@ -26,42 +29,22 @@ export interface Question {
 */
 @Injectable()
 export class AskFedoraService {
-  private API: any;
-  private questions: Question[];
-
-  constructor(private request: Http) {
-    this.API = {
-      base: [API_ENDPOINT],
-      questions: [API_ENDPOINT, 'questions'],
-    };
-
-    this.questions = [];
+  private endpoint:string;
+  constructor(private http: HttpClient, private platform: Platform) {
   }
 
   getQuestions() {
-    if (this.questions.length) {
-      return Promise.resolve(this.questions);
-    }
-
-    return this.request.get(this.API.questions)
-      .toPromise()
-      .then((data: any) => {
-        this.questions = data.questions.map(q => {
-          const question = {
-            id: q.id,
-            title: q.title,
-            link: q.url,
-            answers: q.answer_count,
-            content: q.summary,
-            timestamp: q.added_at,
-            tags: q.tags,
-            view: q.view_count,
-            vote: q.score,
-          };
-          return question;
-        });
-
-        return this.questions;
-      });
+    return this.http.get(`${ENDPOINT}/questions/`)
+      .map((data: any) => data.questions.map(q => ({
+        id: q.id,
+        title: q.title,
+        link: q.url,
+        answers: q.answer_count,
+        content: q.summary,
+        timestamp: q.added_at,
+        tags: q.tags,
+        view: q.view_count,
+        vote: q.score,
+      })));
   }
 }
diff --git a/src/providers/fedo-cal/fedo-cal.ts b/src/providers/fedo-cal/fedo-cal.ts
index cfcc03d..bb24f93 100644
--- a/src/providers/fedo-cal/fedo-cal.ts
+++ b/src/providers/fedo-cal/fedo-cal.ts
@@ -4,17 +4,16 @@ import 'rxjs/add/operator/map';
 import * as _ from 'lodash';
 import * as moment from 'moment-timezone';
 
-import { Http } from '../http/http';
+import { HttpClient } from '@angular/common/http';
+import { Platform } from 'ionic-angular';
+import { Observable } from 'rxjs/Observable';
+import { chooseEndpoint } from '../../utils';
 
-const API_ENDPOINT = 'https://apps.fedoraproject.org/calendar/api/';
-const API = {
-  base: [API_ENDPOINT],
-  calendars: [API_ENDPOINT, 'calendars'],
-  meetings: [API_ENDPOINT, 'meetings'],
-};
+
+const ENDPOINT = chooseEndpoint('/fedocal', 'https://apps.fedoraproject.org/calendar/api');
 
 const DATE_FORMAT = 'dddd, MMMM Do YYYY';
-const TIME_FORMAT = 'h:mm a z';
+const TIME_FORMAT = 'h:mm A z';
 
 /*
   Convert title to capital case, but skip special names like FESCo, FAmSCo, i18n
@@ -28,7 +27,32 @@ function calendarNameToDisplayName(name: string): string {
     default:
       return /^[A-Z][^\d-]*.*$/.test(name) ? name : _.startCase(name);
   }
+}
+
+export interface Calendar {
+  realName: string,
+  displayName: string,
+  description: string,
+  adminGroup: string,
+  editorGroup: string,
+  contact: string,
+  enabled: boolean,
+}
 
+export interface Meeting {
+  name: string,
+  description: string,
+  location: string,
+  time: Date,
+  timeEnd: Date,
+  displayTime: {
+    dateString: string,
+    timeString: string,
+  },
+  displayTimeEnd: {
+    dateString: string,
+    timeString: string,
+  }
 }
 
 /*
@@ -38,81 +62,54 @@ function calendarNameToDisplayName(name: string): string {
   for more info on providers and Angular 2 DI.
 */
 @Injectable()
-export class FedoCal {
-  private calendars: any;
-  private meetings: any;
-
-  constructor(private request: Http) {
-    this.calendars = [];
-    this.meetings = [];
+export class FedoCalService {
+  private endpoint: string;
+  constructor(private http: HttpClient, private platform: Platform) {
   }
 
-  getCalendars() {
-    if (!_.isEmpty(this.calendars)) {
-      return Promise.resolve(this.calendars);
-    }
-
-    return this.request.get(API.calendars)
-      .toPromise()
-      .then((data: any) => {
-        this.calendars = _.map(data.calendars, c => {
-          return {
-            real_name: c.calendar_name,
-            display_name: calendarNameToDisplayName(c.calendar_name),
-            description: c.calendar_description,
-            contact: c.calendar_contact,
-          };
-        });
-
-        return this.calendars
-      });
+  getCalendars(): Observable<Calendar[]> {
+    return this.http.get(`${ENDPOINT}/calendars/`)
+      .map((data: any) =>
+        data.calendars.map((c: any) => ({
+          realName: c.calendar_name,
+          displayName: calendarNameToDisplayName(c.calendar_name),
+          description: c.calendar_description,
+          contact: c.calendar_contact,
+          adminGroup: c.calendar_admin_group,
+          editorGroup: c.calendar_editor_group,
+          enabled: c.calendar_status === 'Enabled'
+        })));
   }
 
-  getMeetings(calendar) {
-    if (!_.isEmpty(this.meetings[calendar])) {
-      return Promise.resolve(this.meetings[calendar]);
-    }
-
-    return this.request.get(API.meetings, { calendar: calendar })
-      .toPromise()
-      .then((data: any) => {
-        this.meetings[calendar] = _.map(data.meetings, m => {
-          const meeting: any = {
-            name: m.meeting_name,
-            real_description: m.meeting_information,
-            display_description: _.truncate(
-              m.meeting_information,
-              { length: 120, separator: ' ' }
-            ),
-            date_start: m.meeting_date,
-            time_start: m.meeting_time_start,
-            date_end: m.meeting_date_end,
-            time_end: m.meeting_time_end,
-            timezone: m.meeting_timezone,
-            location: m.meeting_location,
-          };
-
-          const start = dateToMoment(meeting.date_start, meeting.time_start, meeting.timezone);
-          meeting.moment_start = start;
-          meeting.datetime_start = start.toDate();
-
-          const end = dateToMoment(meeting.date_end, meeting.time_end, meeting.timezone);
-          meeting.moment_end = end;
-          meeting.datetime_end = end.toDate();
-
-          meeting.display_date = start.format(DATE_FORMAT);
-          meeting.display_time = start.format(TIME_FORMAT);
-
-          return meeting;
-        });
-
-        return this.meetings[calendar];
-      });
+  getMeetings(calendar): Observable<Meeting[]> {
+
+    return this.http.get(`${ENDPOINT}/meetings/`, { params: { calendar: calendar } })
+      .map((data: any) => data.meetings.map(m => {
+        const mTime = dateToMoment(m.meeting_date, m.meeting_time_start, m.meeting_timezone);
+        const mTimeEnd = dateToMoment(m.meeting_date_end, m.meeting_time_stop, m.meeting_timezone);
+
+        return {
+          name: m.meeting_name,
+          description: m.meeting_information,
+          time: mTime.toDate(),
+          timeEnd: mTimeEnd.toDate(),
+          displayTime: {
+            dateString: mTime.format(DATE_FORMAT),
+            timeString: mTime.format(TIME_FORMAT)
+          },
+          displayTimeEnd: {
+            dateString: mTimeEnd.format(DATE_FORMAT),
+            timeString: mTimeEnd.format(TIME_FORMAT),
+          },
+          location: m.meeting_location,
+        };
+      }));
   }
 }
 
 
 function dateToMoment(date, time, timezone) {
-  return moment.tz(date + 'T' + time + 'Z', timezone).tz('Etc/UTC');
+  const m = moment.tz(`${date} ${time}`, timezone).tz('UTC');
+  return m;
 }
 
diff --git a/src/providers/fedora-magazine/fedora-magazine.ts b/src/providers/fedora-magazine/fedora-magazine.ts
new file mode 100644
index 0000000..000b79b
--- /dev/null
+++ b/src/providers/fedora-magazine/fedora-magazine.ts
@@ -0,0 +1,68 @@
+import { Injectable } from '@angular/core';
+import 'rxjs/add/operator/map';
+
+import * as _ from 'lodash';
+
+import { HttpClient } from '@angular/common/http';
+import { Observable } from 'rxjs/Observable';
+import { chooseEndpoint } from '../../utils';
+
+const ENDPOINT = chooseEndpoint('/fedora-magazine', 'https://fedoramagazine.org/wp-json/wp/v2');
+
+export interface Post {
+  id: number,
+  link: string,
+  title: string,
+  image: any,
+  excerpt: string,
+  content: string,
+  date: Date
+}
+
+/*
+  Generated class for the FedoraMag provider.
+
+  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
+  for more info on providers and Angular 2 DI.
+*/
+@Injectable()
+export class FedoraMagazineService {
+  constructor(private http: HttpClient) {
+  }
+
+  getPosts(): Observable<Post[]> {
+    return this.http.get(`${ENDPOINT}/posts`)
+      .map((data: any[]) => data.map((post: any) => ({
+        id: post.id,
+        link: post.link,
+        title: post.title.rendered,
+        image: post.featured_media,
+        excerpt: post.excerpt.rendered,
+        content: post.content.rendered,
+        date: new Date(post.date_gmt+'Z'),
+      })));
+  }
+}
+
+  /*  getMedia_url(posts) {
+      if (!_.isEmpty(this.media_url[posts])) {
+        return Promise.resolve(this.media_url[posts]);
+      }
+
+      return new Promise((resolve, reject) => {
+        this.request.get(this.API.media_url,{ posts : posts })
+          .then(data => {
+            this.media_url[posts] = _.map(data, i => {
+            //  var excerpt = p.excerpt.rendered;
+              var img_url = {
+                img_id: i.id,
+                img_link: i.guid.rendered,
+              };
+              //image_url = func_url(post.image);
+              return post;
+            });
+
+            return resolve(this.posts);
+          }).catch(reject);
+      });
+    }*/
diff --git a/src/providers/social/facebook.ts b/src/providers/social/facebook.ts
index a5056e9..48e4ea0 100644
--- a/src/providers/social/facebook.ts
+++ b/src/providers/social/facebook.ts
@@ -3,7 +3,9 @@ import 'rxjs/add/operator/map';
 import ENV from '@environment';
 import { Facebook } from 'fb';
 import { compact } from 'lodash-es';
-import { SocialProvider, Post } from './social';
+import { SocialProvider, Post, FACEBOOK } from './social';
+import { Observable } from 'rxjs/Observable';
+import { Observer } from 'rxjs/Observer';
 
 /*
   Generated class for the Fb provider.
@@ -19,30 +21,33 @@ export class FacebookProvider implements SocialProvider {
   }
 
   private api(uri) {
-    return new Promise((resolve, reject) => {
+    return Observable.create((emitter: Observer<any>) => {
       this.fb.api(uri, res => {
         if (!res || res.error) {
-          return reject(res);
+          emitter.error(res.error);
         } else {
-          return resolve(res);
+          emitter.next(res);
         }
+        emitter.complete();
       });
     });
   }
 
-  public async getPosts(page:string, args?): Promise<Post[]> {
-    const res:any = await this.api(`${page}/posts`);
-    const posts = compact<Post>(res.data.map(p => {
+  public getPosts(page: string, args?): Observable<Post[]> {
+    return this.api(`${page}/posts`)
+      .map(res => {
+        const posts = compact<Post>(res.data.map(p => {
           const post = {
             id: p.id,
             link: 'https://facebook.com/' + p.id,
             content: p.message,
-            origin: 'facebook',
+            origin: FACEBOOK,
           };
 
           return post.content ? post : null;
         }));
 
         return posts;
+      });
   }
 }
diff --git a/src/providers/social/social.ts b/src/providers/social/social.ts
index b8d9482..8832ffe 100644
--- a/src/providers/social/social.ts
+++ b/src/providers/social/social.ts
@@ -1,3 +1,4 @@
+import { Observable } from "rxjs/Observable";
 
 export const FACEBOOK = 'facebook';
 export const TWITTER = 'twitter';
@@ -6,7 +7,7 @@ export interface Post {
   id:string,
   origin:string,
   link:string,
-  // date: Date,
+  content:string,
 }
 
 export interface GetPostExtraArgs {
@@ -14,5 +15,5 @@ export interface GetPostExtraArgs {
 }
 
 export interface SocialProvider {
-  getPosts(resID: string, args?:GetPostExtraArgs): Promise<Post[]>
+  getPosts(resID: string, args?:GetPostExtraArgs): Observable<Post[]>
 }
diff --git a/src/providers/social/twitter.ts b/src/providers/social/twitter.ts
index af1bd6b..59bf6d2 100644
--- a/src/providers/social/twitter.ts
+++ b/src/providers/social/twitter.ts
@@ -1,21 +1,18 @@
 import { Injectable } from '@angular/core';
 import 'rxjs/add/operator/map';
+import 'rxjs/add/operator/do';
 import * as _ from 'lodash';
 
 import ENV from '@environment';
 
-import { Http } from '../http/http';
 import { SocialProvider, Post } from './social';
+import { HttpClient } from '@angular/common/http';
+import { Platform } from 'ionic-angular';
+import { chooseEndpoint } from '../../utils';
+import { Observable } from 'rxjs/Observable';
+import { from } from 'rxjs/observable/from';
 
-
-const API_ENDPOINT = 'https://api.twitter.com/1.1/';
-
-const API: any = {
-  base: [API_ENDPOINT],
-  statuses: [API_ENDPOINT, 'statuses'],
-}
-API.timeline = API.statuses.concat(['user_timeline.json']);
-
+const ENDPOINT = chooseEndpoint('/twitter', 'https://api.twitter.com/1.1');
 
 /*
   Generated class for the Twitter provider.
@@ -26,22 +23,20 @@ API.timeline = API.statuses.concat(['user_timeline.json']);
 @Injectable()
 export class TwitterProvider implements SocialProvider {
 
-  constructor(private http: Http) { }
-
-  public async getPosts(handle:string, args?): Promise<Post[]> {
-    const response = (await this.http.get(
-      API.timeline, { screen_name: handle },
-      { 'Authorization': 'Bearer ' + ENV.TWITTER_CONFIG.BEARER_TOKEN }
-    ).toPromise() as any[]);
-
-    return response.map<Post>(t => {
-      return {
-        id: t.id,
-        link: 'https://twitter.com/statuses/' + t.id_str,
-        content: t.text,
-        origin: 'twitter',
-      };
-    });
+  private endpoint: string;
+  constructor(private http: HttpClient, private platform: Platform) {
+  }
+
+  public getPosts(handle: string, args?): Observable<Post[]> {
+    return this.http.get(`${ENDPOINT}/statuses/user_timeline.json`, {
+      params: { screen_name: handle },
+      headers: { 'Authorization': 'Bearer ' + ENV.TWITTER_CONFIG.BEARER_TOKEN }
+    }).map((tweetsResponse: any) => tweetsResponse.map(t => ({
+      id: t.id,
+      link: 'https://twitter.com/statuses/' + t.id_str,
+      content: t.text,
+      origin: 'twitter',
+    })));
   }
 }
 
diff --git a/src/utils.ts b/src/utils.ts
index e69de29..25bc712 100644
--- a/src/utils.ts
+++ b/src/utils.ts
@@ -0,0 +1,10 @@
+
+/**
+ * Choose appropriate API end point or the proxy to avoid CORS in Ionic dev server
+ * @param devServerEndpoint endpoint in Ionic dev server
+ * @param appEndpoint endpoint to use in real application
+ */
+export function chooseEndpoint(devServerEndpoint:string, appEndpoint:string) {
+  // courtesy: https://forum.ionicframework.com/t/check-if-run-on-emulator-dev-production-or-livereload/71845/9
+  return window.hasOwnProperty('IonicDevServer') ? devServerEndpoint : appEndpoint;
+}

